"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SideBar = SideBar;
function _react() {
  const data = _interopRequireWildcard(require("react"));
  _react = function () {
    return data;
  };
  return data;
}
function _lodash() {
  const data = require("lodash");
  _lodash = function () {
    return data;
  };
  return data;
}
function _classnames() {
  const data = _interopRequireDefault(require("classnames"));
  _classnames = function () {
    return data;
  };
  return data;
}
function _designUiSurfacesMenu() {
  const data = require("@teambit/design.ui.surfaces.menu.section");
  _designUiSurfacesMenu = function () {
    return data;
  };
  return data;
}
function _uiFoundationUiTree() {
  const data = require("@teambit/ui-foundation.ui.tree.drawer");
  _uiFoundationUiTree = function () {
    return data;
  };
  return data;
}
function _sideBarModule() {
  const data = _interopRequireDefault(require("./side-bar.module.scss"));
  _sideBarModule = function () {
    return data;
  };
  return data;
}
const _excluded = ["drawerSlot", "items", "overrideDrawerSlot"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], t.indexOf(o) >= 0 || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.indexOf(n) >= 0) continue; t[n] = r[n]; } return t; }
/**
 * side bar component.
 */
function SideBar(_ref) {
  let {
      drawerSlot,
      items = [],
      overrideDrawerSlot
    } = _ref,
    rest = _objectWithoutProperties(_ref, _excluded);
  const drawers = (overrideDrawerSlot || (0, _lodash().flatten)(drawerSlot.values())).filter(drawer => !drawer?.isHidden?.()).sort(sortFn);
  const [openDrawerList, onToggleDrawer] = (0, _react().useState)(drawers.map(drawer => drawer.id));
  const handleDrawerToggle = id => {
    const isDrawerOpen = openDrawerList.includes(id);
    if (isDrawerOpen) {
      onToggleDrawer(list => list.filter(drawer => drawer !== id));
      return;
    }
    onToggleDrawer(list => list.concat(id));
  };
  return /*#__PURE__*/_react().default.createElement("div", _extends({}, rest, {
    className: _sideBarModule().default.sidebar
  }), /*#__PURE__*/_react().default.createElement(_designUiSurfacesMenu().MenuSection, {
    items: items
  }), drawers.map(drawer => {
    if (!drawer || !drawer.name) return null;
    // consider passing collapse all as a prop so each drawer collapses itself
    const isOpen = openDrawerList.includes(drawer.id);
    return /*#__PURE__*/_react().default.createElement(_uiFoundationUiTree().DrawerUI, {
      className: (0, _classnames().default)(_sideBarModule().default.sidebarDrawer, isOpen && _sideBarModule().default.open),
      isOpen: isOpen,
      onToggle: () => handleDrawerToggle(drawer.id),
      key: drawer.id,
      name: drawer.name,
      Widgets: drawer.widgets,
      Context: drawer.Context
    }, /*#__PURE__*/_react().default.createElement(drawer.render, null));
  }));
}
function sortFn(first, second) {
  // 0  - equal
  // <0 - first < second
  // >0 - first > second

  return (first.order ?? 0) - (second.order ?? 0);
}

//# sourceMappingURL=side-bar.js.map